require 'sketchup.rb'
require 'extensions.rb'

if Sketchup.version.to_i >= 16

module AMS
  module ClothWorks

    NAME         = 'ClothWorks'.freeze
    VERSION      = '1.1.1'.freeze
    RELEASE_DATE = 'April 3, 2018'.freeze

    @extension = ::SketchupExtension.new(NAME, 'ams_ClothWorks/main_entry')

    desc = "A cloth simulation extension for draping cloth over objects and simulating curtains, ropes, flags, and more."

    @extension.description = desc
    @extension.version     = VERSION
    @extension.copyright   = 'Anton Synytsia © 2018'
    @extension.creator     = 'Anton Synytsia'

    ::Sketchup.register_extension(@extension, true)

    class << self
      attr_reader :extension
    end # class << self

  end # class ClothWorks
end # module AMS

else
  UI.messagebox("AMS ClothWorks requires SketchUp 2016 or later to run! It is not compatible with your SketchUp version and will, therefore, not be loaded.")
end
