var g_ms_ie = null;
var g_chrome = null;

String.prototype.contains = function(it) { return this.indexOf(it) != -1; };

function is_int(n) {
  return typeof n === 'number' && parseFloat(n) == parseInt(n, 10) && !isNaN(n);
}

function type(obj) {
  return Object.prototype.toString().call(obj).slice(8, -1);
}

function callback(name, data) {
  if (!data) data = '';
  if (typeof sketchup === 'undefined') {
    window.location.href = 'skp:' + name + '@' + data;
  } else {
    window['sketchup'][name](data);
  }
}

function init() {
  var ua = window.navigator.userAgent;
  var old_ie = ua.indexOf('MSIE ');
  var new_ie = ua.indexOf('Trident/');
  g_ms_ie = ((old_ie > -1) || (new_ie > -1)) ? true : false;
  g_chrome = ua.toLowerCase().indexOf('chrome') > -1;

  var cw = $(window).width();
  var ch = $(window).height();
  var bw = 280;
  var bh = 660;
  var data = '['+cw+','+ch+','+bw+','+bh+']';

  callback('init', data);
}

function display_help_box(state) {
  $('#help_box').css('display', state ? 'inline-block': 'none');
}

$(document).ready( function() {
  // Initialize
  window.setTimeout(init, 0);

  // Process checkbox and radio input triggers.
  $( 'input[type=checkbox], input[type=radio]' ).change( function() {
    var data = '['+':'+this.id+','+this.checked+']';
    callback('input_changed', data);
  });

  // Process button clicks
  $( 'input[type=button]' ).click( function() {
    callback('button_clicked', this.id);
  });

  // Detect selectable
  $('select').bind( "change", function(event, ui) {
    var data = '['+':'+ this.id+','+this.value+']';
    callback('select_changed', data);
  });

  // Detect slider movements.
  $('input').each( function(index) {
    if (typeof this.id == 'string' && this.id.length > 6 && this.id.substr(0, 6) == 'slider') {
      var hid = '#' + this.id;
      $(hid).change( function(event, ui) {
        var data = '['+':'+ this.id+','+this.value+']';
        callback('slider_slide', data);
      });

      $(hid).on( 'slidestart', function( event ) {
        var data = '['+':'+ this.id+','+this.value+']';
        callback('slider_slide_start', data);
      });

      $(hid).on( 'slidestop', function( event ) {
        var data = '['+':'+ this.id+','+this.value+']';
        callback('slider_slide_stop', data);
      });
    }
  });

  $('.ui-slider-input').on('blur', function() {
    var data = '['+':'+ this.id+','+this.value+']';
    callback('slider_slide_stop', data);
  });

  $( window ).focus( function() {
    callback('window_focus');
  });

  $( window ).blur( function() {
    callback('window_blur');
  });

  $(document).on('mouseenter', function() {
    callback('mouse_enter');
  });

  $(document).on('mouseleave', function() {
    callback('mouse_leave');
  });

  $('#help_box').val("");

  $('a,p,label,input,button').mouseover(function() {
    try {
      var p1 = this.parentElement;
      var p2 = p1 ? p1.parentElement : null;

      if (this.title != "") {
        $('#help_box').val(this.title);
      }
      else if (p1 && p1.title != "") {
        $('#help_box').val(p1.title);
      }
      else if (p2 && p2.title != "") {
        $('#help_box').val(p2.title);
      }
      else {
        $('#help_box').val("");
      }
    } catch(err) {
      $('#help_box').val("");
    }
  });

});
